﻿

Partial Public Class MainPage
    Inherits UserControl

    'oggetto per stampare
    Private pd As New Printing.PrintDocument()

    'oggetto input penna
    Dim inkPresenter1 As New InkPresenter
    Dim stroke1 As Stroke
    Public Sub New()
        InitializeComponent()
        'creo uno sfondo alla tavoletta da disegno
        inkPresenter1.Background = New SolidColorBrush(Colors.Orange)
        inkPresenter1.Height = 500
        inkPresenter1.Width = 500
        'lo aggrego alla griglia
        LayoutRoot.Children.Add(inkPresenter1)

        'Aggiungo i metodi all'oggetto InkPresenter
        AddHandler inkPresenter1.MouseLeftButtonDown, AddressOf inkPresenter1_MouseLeftButtonDown
        AddHandler inkPresenter1.MouseLeftButtonUp, AddressOf inkPresenter1_MouseLeftButtonUp
        AddHandler inkPresenter1.MouseMove, AddressOf inkPresenter1_MouseMove
        'aggiungo metoto all'oggetto printdocument
        AddHandler pd.PrintPage, AddressOf pd_PrintPage
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button1.Click



        ' Creo segmenti
        Dim segment1Start As New StylusPoint(200, 110)
        Dim segment1End As New StylusPoint(185, 150)
        Dim segment2Start As New StylusPoint(185, 150)
        Dim segment2End As New StylusPoint(135, 150)

        'li aggiungo alla proprietà stroke (ovvero render statico)

        Dim strokePoints As New StylusPointCollection()

        strokePoints.Add(segment1Start)
        strokePoints.Add(segment1End)
        strokePoints.Add(segment2Start)
        strokePoints.Add(segment2End)
        'aggiungo all' oggetto inkPresenter
        Dim newStroke As New Stroke(strokePoints)
        inkPresenter1.Strokes.Add(newStroke)



    End Sub

 
    Private Sub inkPresenter1_MouseLeftButtonDown(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs)
        stroke1 = New Stroke()
        inkPresenter1.Strokes.Add(stroke1)
    End Sub
    Private Sub inkPresenter1_MouseLeftButtonUp(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseButtonEventArgs)
        stroke1 = Nothing
    End Sub
    Private Sub inkPresenter1_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Input.MouseEventArgs)
        If Not stroke1 Is Nothing Then
            stroke1.StylusPoints.Add(e.StylusDevice.GetStylusPoints(inkPresenter1))
        End If
    End Sub

    Private Sub BtnClear_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles BtnClear.Click
        inkPresenter1.Strokes.Clear()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles Button2.Click
        'nome del documento mandato in stampa
        pd.Print("disegno Aleci - Bruno")
    End Sub
    Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As Printing.PrintPageEventArgs)
        'specifico l'oggetto da stampare
        e.PageVisual = inkPresenter1
    End Sub
End Class


